API_GetMenuItemID( hMenu, nPos ) {
	return DllCall("GetMenuItemID", "uint", hMenu, "int", nPos)
}
API_GetSubmenu( hMenu, nPos ) {
	return DllCall("GetSubMenu", "uint", hMenu, "int", nPos)
}
API_GetMenuItemsCount(hMenu)
{
	return DllCall("GetMenuItemCount", "Uint", hMenu, "Uint")
}
GetMenuString(hMenu, nPos)
{
	length := DllCall("GetMenuString"
			, "UInt", hMenu
			, "UInt", nPos
			, "UInt", 0	; NULL
			, "Int", 0	; Get length
			, "UInt", 0x0400)	; MF_BYPOSITION
		VarSetCapacity(lpString, length + 1)	; I don't check the result...
		length := DllCall("GetMenuString"
			, "UInt", hMenu
			, "UInt", nPos
			, "Str", lpString
			, "Int", length + 1
			, "UInt", 0x0400)
	return lpString
}
findMenuItem(hMenu, name) {
	RepeatCount := API_GetMenuItemsCount(hMenu)
	Loop %RepeatCount% {
    	nPos := A_Index - 1
    	if GetMenuString(hMenu, nPos)=name {
    		return nPos
    	}
	}
	return -1
}

runScript(name, name2="")
{
	SendInput,{APPSKEY}	
	Sleep, 100
	if WinExist("ahk_class #32768")
	{ 		
		;WinGet, activeWindow, ID
		;hWnd := activeWindow 
		;activeWindow := DllCall("GetWindow", "Uint", activeWindow, "Uint", 4, "Uint")
		SendMessage,0x01E1
		hmenu := ErrorLevel
		nPos := -1
		nPos2 := -1
		if hmenu!=1
		{
			itemCount := API_GetMenuItemsCount(hmenu)
			if(findMenuItem(hmenu, "Scripts")=(itemCount-1))
			{
				hmenu := API_GetSubMenu(hmenu, itemCount-1)
				nPos := findMenuItem(hmenu, name)
				;MsgBox % "m2 " . nPos
				if(nPos != -1 and name2 != "")
				{
					hMenu2 := API_GetSubMenu(hmenu, nPos)					
					nPos2 := findMenuItem(hmenu2, name2)
					;MsgBox % "m2 " . nPos2
				}

				if((nPos2 != -1) or (nPos != -1 and name2 = ""))
				{
					SendInput,{UP}{ENTER}
					Loop %nPos% 
					{
						SendInput,{DOWN}
					}
					SendInput,{ENTER}	

					if(name2 <> "")
					{
						Loop %nPos2% {
							SendInput,{DOWN}
						}
						SendInput,{ENTER}	
					}
				}
			}

		}
	}
}


#InstallKeybdHook force
SetTitleMatchMode,2

#IfWinActive, ahk_class AxaptaClientClassName
#x::
  	WinMenuSelectItem,,,,Go component	
Exit

#IfWinActive, ahk_class AxaptaClientClassName
#z::
  	WinMenuSelectItem,,,,X++ calculator
Exit


#IfWinActive, ahk_class AxaptaClientClassName
#1::
	;activeWindow :=  DllCall("GetActiveWindow", "uint")
	WinGet, activeWindow, ID, A
	SendInput,{APPSKEY}	
	Sleep, 10
	if WinExist("ahk_class #32768")
	{ 		
		;WinGet, activeWindow, ID
		;hWnd := activeWindow 
		;activeWindow := DllCall("GetWindow", "Uint", activeWindow, "Uint", 4, "Uint")
		SendMessage,0x01E1
		hmenu := ErrorLevel
		if hmenu!=1
		{
			itemCount := API_GetMenuItemsCount(hmenu)
			mii_fMask := MIIM_ID
			itemID := API_GetMenuItemID(hmenu, itemCount-1)
			hmenu := API_GetSubMenu(hmenu, itemCount-1)
			;itemID := API_GetMenuItemID(hmenu, 6)
			nPos := findMenuItem(hmenu, "go")
			itemCount := API_GetMenuItemsCount(hmenu)
			s := GetMenuString(hMenu, 1)

			if nPos > -1 
			{
				SendInput,{UP}{ENTER}
				Loop %nPos% 
				{
					SendInput,{DOWN}
				}
			}
			SendInput,{ENTER}	
			MsgBox % "iid " . nPos . "nc " . itemCount . " 2:" . s
		}
		MsgBox % "test" . hWnd . " | " . activeWindow	
	}
	
Exit


#IfWinActive, ahk_class AxaptaClientClassName
~^Enter::
     ;toEnglish()
     runScript("go")
Exit

; Win+C comment
#IfWinActive, ahk_class AxaptaClientClassName
#c::
	runScript("comments", "comment")
      ;;toEnglish()
      ;SendInput,{APPSKEY}s{vk43sc02E}{ENTER}{vk43sc02E}   
Exit

; Ctrl+Win+C uncomment
#IfWinActive, ahk_class AxaptaClientClassName
^#c::
	runScript("comments", "uncomment")
     ;toEnglish()
     ;SendInput,{APPSKEY}sc{ENTER}u 
Exit

; AddModificationSign with request
#IfWinActive, ahk_class AxaptaClientClassName
~^m::
      ;toEnglish()
      SendInput,{APPSKEY}sc{ENTER}w 
Exit

; Ctrl+Win+M AddModificationSign without request
#IfWinActive, ahk_class AxaptaClientClassName
^#m::
      ;toEnglish()
      SendInput,{APPSKEY}sc{ENTER}w{ENTER}
Exit


; Win+P Projects
#IfWinActive, ahk_class AxaptaClientClassName
#p::
  	;toEnglish()
	SendMessage,0x111,281
	SendInput  {DOWN}{DOWN}{RIGHT}{DOWN}
Exit

; Ctrl+F1 Developers Guide
#IfWinActive, ahk_class AxaptaClientClassName
~^F1::
  	SendMessage,0x111,296
Exit

; Ctrl+Win+P New Project
#IfWinActive, ahk_class AxaptaClientClassName
^#p::
  	;toEnglish()
	SendMessage,0x111,281
	SendInput,{DOWN}{DOWN}
	SendInput,{CTRLDOWN}n{CTRLUP}{F2}
Exit

; Ctrl+Win+Numpad 1 - vss check in
#IfWinActive, ahk_class AxaptaClientClassName
^#Numpad1::
	;toEnglish()
  SendInput,{APPSKEY}av{ENTER}	   
Exit

; Ctrl+Win+Numpad 0 - vss add
#IfWinActive, ahk_class AxaptaClientClassName
^#Numpad0::
	;toEnglish()
  SendInput,{APPSKEY}ava
Exit
; Ctrl+Win+Numpad 7 - vss history
#IfWinActive, ahk_class AxaptaClientClassName
^#Numpad7::
	;toEnglish()
  SendInput,{APPSKEY}avh
Exit

; Alt + Shift + Ins -   
#IfWinActive, ahk_class AxaptaClientClassName
!+Insert::
   WinMenuSelectItem,,,,Copy,Copy AOT Names
Exit
; Ctrl + Alt + Ins -   
#IfWinActive, ahk_class AxaptaClientClassName
!^Insert::
   WinMenuSelectItem,,,,Copy,Copy AOT Pathes
Exit

;Cltrl+Win+T -- table browser here
#IfWinActive, ahk_class AxaptaClientClassName
^#t::
	WinMenuSelectItem,,,,Dev,TableBrowserHere
Exit
